fuzzydl

## Class LinearConcreteConcept

- java.lang.Object
- - fuzzydl.Concept
  - - fuzzydl.FuzzyConcreteConcept
    - - fuzzydl.LinearConcreteConcept

-     public class LinearConcreteConcept
      extends FuzzyConcreteConcept

  Fuzzy concrete concept defined with a left shoulder function.
  Author:
    Fernando Bobillo

- - ### Field Summary

    - ### Fields inherited from class fuzzydl.Concept

      `ALL, AND, AT_LEAST_VALUE, AT_MOST_VALUE, ATOMIC, BOTTOM, CHOQUET_INTEGRAL, COMPLEMENT, CONCEPT_BOTTOM, CONCEPT_TOP, CONCRETE, CONCRETE_COMPLEMENT, DEFAULT_NAME, EXACT_VALUE, EXT_NEG_THRESHOLD, EXT_POS_THRESHOLD, FUZZY_NUMBER, FUZZY_NUMBER_COMPLEMENT, G_AND, G_IMPLIES, G_OR, HAS_VALUE, L_AND, L_OR, LOOSE_LOWER_APPROX, LOOSE_UPPER_APPROX, LOWER_APPROX, MODIFIED, MODIFIED_COMPLEMENT, NEG_THRESHOLD, NOT_AT_LEAST_VALUE, NOT_AT_MOST_VALUE, NOT_CHOQUET_INTEGRAL, NOT_EXACT_VALUE, NOT_EXT_NEG_THRESHOLD, NOT_EXT_POS_THRESHOLD, NOT_G_IMPLIES, NOT_HAS_VALUE, NOT_NEG_THRESHOLD, NOT_OWA, NOT_POS_THRESHOLD, NOT_QUANTIFIED_OWA, NOT_QUASI_SUGENO_INTEGRAL, NOT_SELF, NOT_SUGENO_INTEGRAL, NOT_W_MAX, NOT_W_MIN, NOT_W_SUM, NOT_W_SUM_ZERO, NOT_WEIGHTED, NOT_Z_IMPLIES, OR, OWA, POS_THRESHOLD, QUANTIFIED_OWA, QUASI_SUGENO_INTEGRAL, SELF, SOME, SUGENO_INTEGRAL, TIGHT_LOWER_APPROX, TIGHT_UPPER_APPROX, TOP, UPPER_APPROX, W_MAX, W_MIN, W_SUM, W_SUM_ZERO, WEIGHTED, Z_IMPLIES`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `LinearConcreteConcept(java.lang.String name, double k1, double k2, double a, double b)`
    `LinearConcreteConcept(java.lang.String name, int type, double k1, double k2, double a, double b)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `Concept` | `complement()` Gets the complement of the concept.
    `double` | `getMembershipDegree(double x)` Gets the image in [0,1] of a real number to the explicit membership function.
    `java.lang.String` | `getName()` Gets the definition of the CFC as a string.
    `void` | `solveAssertion(CreatedIndividual ind, Degree lowerLimit, KnowledgeBase kb)` Solves an assertion of the form (individual, concept, degree) with respect to a fuzzy KB.

    - ### Methods inherited from class fuzzydl.FuzzyConcreteConcept

      `computeName, setK1, setK2, solveComplementAssertion, toString`

    - ### Methods inherited from class fuzzydl.Concept

      `all, and, and, atLeastValue, atMostValue, complement, containsNegatedSubconcept, containsSubconcept, equals, exactValue, extendedNegThreshold, extendedPosThreshold, gAnd, gAnd, getAtomicConceptNames, getAtomicConcepts, getRole, getType, getValue, getWeight, getWeightVar, gImplies, gOr, gOr, hasNominals, hasValue, hasValue, isAtomic, isComplementedAtomic, isConcrete, kdImplies, lAnd, lAnd, lImplies, looseLowerApprox, looseUpperApprox, lOr, lOr, lowerApprox, nAry, negThreshold, newAtomicConcept, notHasValue, or, or, posThreshold, removeElement, replace, self, setName, setType, setValue, some, tightLowerApprox, tightUpperApprox, upperApprox, weightedConcept, zImplies`

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### LinearConcreteConcept

          public LinearConcreteConcept(java.lang.String name,
                                       double k1,
                                       double k2,
                                       double a,
                                       double b)
                                throws FuzzyOntologyException

      Throws:
        `FuzzyOntologyException`

    - #### LinearConcreteConcept

          public LinearConcreteConcept(java.lang.String name,
                                       int type,
                                       double k1,
                                       double k2,
                                       double a,
                                       double b)
                                throws FuzzyOntologyException

      Throws:
        `FuzzyOntologyException`

  - ### Method Detail

    - #### complement

          public Concept complement()
                             throws FuzzyOntologyException

      Description copied from class: `FuzzyConcreteConcept`
      Gets the complement of the concept.
      Specified by:
        `complement` in class `FuzzyConcreteConcept`
      Returns:
        The complement of the concept.
      Throws:
        `FuzzyOntologyException` - fuzzy ontology exception.

    - #### solveAssertion

          public void solveAssertion(CreatedIndividual ind,
                                     Degree lowerLimit,
                                     KnowledgeBase kb)

      Description copied from class: `FuzzyConcreteConcept`
      Solves an assertion of the form (individual, concept, degree) with respect to a fuzzy KB.
      Specified by:
        `solveAssertion` in class `FuzzyConcreteConcept`
      Parameters:
        `ind` - Subject of the assertion.
        `lowerLimit` - Lower bound of the assertion.
        `kb` - Fuzzy KB.

    - #### getMembershipDegree

          public double getMembershipDegree(double x)

      Description copied from class: `FuzzyConcreteConcept`
      Gets the image in [0,1] of a real number to the explicit membership function.
      Specified by:
        `getMembershipDegree` in class `FuzzyConcreteConcept`
      Parameters:
        `x` - A real number in the range of values of the explicit membership function.
      Returns:
        Image in [0,1] of x to the explicit membership function.

    - #### getName

          public java.lang.String getName()

      Description copied from class: `FuzzyConcreteConcept`
      Gets the definition of the CFC as a string.
      Specified by:
        `getName` in class `FuzzyConcreteConcept`
      Returns:
        Definition of the CFC.